#ifndef IKD_DIX_BOUNDARYBLOCK_H
#define IKD_DIX_BOUNDARYBLOCK_H

// BoundaryBlockNX
//
//  HEADER̓[U`̑O^OŁA
//  Ǘ̃TCYێ郁oΐ܂B
//  ENDTAG͐TCY̑ZqΊgo܂B

#include <new.h>

namespace Dix {
	////////////////////////////////
	// BondaryBlockpwb_[t@Cij
	//
	class BoundaryBlockHeader {
		unsigned size;
	public:
		BoundaryBlockHeader() : size() {}
		unsigned getSize() {return size;}
		void setSize(unsigned size) {this->size = size;}
	};


	////////////////////////////////
	// BoundaryblockNX
	//
	template<class HEADER = BoundaryBlockHeader, class ENDTAG = unsigned>
	class BoundaryBlock {
		HEADER header;

		// [^O
		void writeEndTag() {
			new((char*)this + getBlockSize() - getEndTagSize()) ENDTAG(getBlockSize());
		}

		// [^OTCY擾
		unsigned getEndTagSize() {
			return sizeof(ENDTAG);
		}

	public:
		BoundaryBlock(unsigned size) {
			header.setSize(size);
			writeEndTag();
		};

		// Ǘւ̃|C^擾
		void* getMemory() {
			return (char*)this + sizeof(BoundaryBlock);
		}

		// ǗTCY擾
		unsigned getMemorySize() {
			return header.getSize();
		}

		// ubNTCY擾
		unsigned getBlockSize() {
			return sizeof(BoundaryBlock) + header.getSize() + getEndTagSize();
		}

		// ̃ubNւ̃|C^擾
		BoundaryBlock *next() {
			return (BoundaryBlock*)((char*)this + getBlockSize());
		}

		// ÕubNւ̃|C^擾
		BoundaryBlock *prev() {
			unsigned *preSize = (unsigned*)((char*)this - getEndTagSize());
			return (BoundaryBlock*)((char*)this - *preSize);
		}

		// EubN}[W
		void marge() {
			// EubN擾
			BoundaryBlock *nextBlock = next();
			// ^OύX
			unsigned newSize = header.getSize() + getEndTagSize() +
				sizeof(BoundaryBlock) +	nextBlock->getMemorySize();
			header.setSize(newSize);
			writeEndTag();
		}

		// ubN𕪊
		BoundaryBlock *split(unsigned size) {
			// VKubNTCYNULL
			unsigned needSize = size + getEndTagSize() + sizeof(BoundaryBlock);
			if (needSize > header.getSize())
				return 0;

			// VKubÑTCYZo
			unsigned newBlockMemSize = header.getSize() - needSize;

			// TCYTCYɏk
			header.setSize(size);
			writeEndTag();

			// VKubN쐬
			BoundaryBlock *newBlock = next();
			new (newBlock) BoundaryBlock(newBlockMemSize);

			return newBlock;
		}

		// wTCYɕ\H
		bool enableSplit(unsigned size) {
			// VKubNTCYNULL
			unsigned needSize = size + getEndTagSize() + sizeof(BoundaryBlock);
			if (needSize > header.getSize())
				return false;
			return true;
		}
	};
}

#endif
